﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PdfSharp.Pdf;
using PdfSharp.Drawing;
using PdfSharp.Drawing.Layout;
using System.IO;

namespace arabictest
{
    class Program
    {
        static void Main(string[] args)
        {
            string s = "الإمارات العربية المتحدة";

            PdfDocument pdf = new PdfDocument();
            pdf.Version = 17;
            PdfPage pdfPage = pdf.AddPage();
            XGraphics graph = XGraphics.FromPdfPage(pdfPage);

            XTextFormatter fmt = new XTextFormatter(graph);
            XRect rc = new XRect(10, 10, pdfPage.Width - 20, pdfPage.Height - 20);
            XPdfFontOptions options = new XPdfFontOptions(PdfFontEncoding.Unicode);
            XFont font = new XFont("Arial", 16, XFontStyle.Regular, options);
            graph.DrawRectangle(XBrushes.SeaShell, rc);
            fmt.Alignment = XParagraphAlignment.Left;
            fmt.DrawString_RTL(s, font, XBrushes.Black, rc, XStringFormats.TopLeft);

            string path = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            string file = Path.Combine(path, "test_ar.pdf");
            try
            {
                pdf.Save(file);
            }
            catch (Exception ex)
            {
                Console.WriteLine("Save failed: " + ex.Message);
            }
            pdf.Dispose();
            Console.WriteLine("done");
            Console.ReadKey();
        }
    }
}
