﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PdfSharp.Pdf;
using PdfSharp.Drawing;
using PdfSharp.Drawing.Layout;
using System.IO;

namespace chinesetest
{
    // This sample requires the Source Han Sans SC font to be installed!
    class Program
    {
        static void Main(string[] args)
        {
            string s = "中國";

            PdfDocument pdf = new PdfDocument();
            pdf.Version = 17;
            PdfPage pdfPage = pdf.AddPage();
            XGraphics graph = XGraphics.FromPdfPage(pdfPage);

            XRect rc = new XRect(10, 10, pdfPage.Width -20, pdfPage.Height -20);
            XPdfFontOptions options = new XPdfFontOptions(PdfFontEncoding.Unicode);
            XFont font = new XFont("Source Han Sans SC", 16, XFontStyle.Regular, options);
            font.PDFFontName = "SourceHanSansSC-Regular";
            graph.DrawString(s, font, XBrushes.Black, rc, XStringFormats.Center);
            graph.Dispose();

            string path = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            string file = Path.Combine(path, "test_cn.pdf");
            try
            {
                pdf.Save(file);
            }
            catch (Exception ex)
            {
                Console.WriteLine("Save failed: " + ex.Message);
            }  
            pdf.Dispose();
            Console.WriteLine("done");
            Console.ReadKey();
        }
    }
}
