﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PdfSharp.Pdf;
using PdfSharp.Drawing;
using PdfSharp.Drawing.Layout;
using System.IO;
using PdfSharp.Pdf.Content;
using PdfSharp.Pdf.Content.Objects;
using PdfSharp.Pdf.IO;

namespace hinditest
{ 

    class Program
    {
        static void Main(string[] args)
        {
            // Output file will be stored on desktop. Font file must be located in the Windows Font folder
            string desktop_path = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            string font_path = Environment.GetFolderPath(Environment.SpecialFolder.Fonts);
            string file = Path.Combine(desktop_path, "test_hi.pdf");
            string fontfile = Path.Combine(font_path, "NotoSansDevanagari-Regular.ttf");

            string s = "अनुच्छेद 1 (एक) – सभी मनुष्यों को गौरव और अधिकारों के विषय में जन्मजात स्वतन्त्रता और समानता प्राप्त हैं। उन्हें बुद्धि और अन्तरात्मा की देन प्राप्त है और परस्पर उन्हें भाईचारे के भाव से बर्ताव करना चाहिए।";

            PdfSharp.pdf_settings.UseHarfBuzz = true;
            PdfSharp.pdf_settings.LoadHarfBuzz(fontfile);
            PdfSharp.pdf_settings.FontEmbedding = true;
 
            DateTime dt = DateTime.Now;
            PdfDocument pdf = new PdfDocument();
            pdf.Options.CompressContentStreams = false;
            pdf.Version = 17;

            PdfPage pdfPage = pdf.AddPage();
            XGraphics graph = XGraphics.FromPdfPage(pdfPage);

            XTextFormatter fmt = new XTextFormatter(graph);
            XRect rc = new XRect(10, 10, pdfPage.Width - 20, pdfPage.Height - 20);
            XPdfFontOptions options = new XPdfFontOptions(PdfFontEncoding.Unicode);
            XFont font = new XFont("Noto Sans Devanagari", 16, XFontStyle.Regular, options);

            fmt.Alignment = XParagraphAlignment.Left;
            fmt.DrawString(s, font, XBrushes.Black, rc, XStringFormats.TopLeft);


            try
            {
                pdf.Save(file);
            }
            catch (Exception ex)
            {
                Console.WriteLine("Save failed: " + ex.Message);
            }
            pdf.Dispose();
            PdfSharp.pdf_settings.UnloadHarfBuzz();

            Console.WriteLine(DateTime.Now.Subtract(dt).TotalMilliseconds);
            Console.WriteLine("done");
            Console.ReadKey();
        }
    }
}
